Imports System.Data.SqlClient
Imports Logic.NullableDateExtensions
Imports Logic.DateExtensions
Imports ReportingClass

Public Class Accidents1
    Inherits System.Web.UI.Page

    Private Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Try

            If Not Page.IsPostBack Then
                If Not _HasVisited() Then
                    _Prefill()
                End If
                _LoadForm()
                _LoadLists()
            Else
                _SaveAll()
                Page.Validate()
                If Page.IsValid Then
                    Master.EnableNextPage()
                End If
            End If

        Catch ex As Exception
            Dim errorId = Logic.Error.Log(ex)
            Response.Redirect("/Error.aspx?id=" & errorId)
        End Try
    End Sub

    Private Sub btnAddAccident_Click(sender As Object, e As EventArgs) Handles rptAccidents.AddClick
        Try
            If _HasEnteredLastAccident() Then
                rptAccidents.TargetCount = Math.Max(rptAccidents.TargetCount, rptAccidents.Items.Count) + 1
            End If
            _LoadAccidentList()
        Catch ex As Exception
            Dim errorId = Logic.Error.Log(ex)
            Response.Redirect("/Error.aspx?id=" & errorId)
        End Try
    End Sub

    Protected Sub btnRemoveAccident_Click(sender As Object, e As EventArgs)
        Try

            rptAccidents.TargetCount = Math.Max(rptAccidents.TargetCount, rptAccidents.Items.Count) - 1

            Dim btnRemove = DirectCast(sender, Button)
            Dim item = DirectCast(btnRemove.Parent, RepeaterItem)
            Dim hidId = DirectCast(item.FindControl("hidAccidentId"), HiddenField)

            _RemoveAccident(CInt(hidId.Value))
            _LoadAccidentList()

        Catch ex As Exception
            Dim errorId = Logic.Error.Log(ex)
            Response.Redirect("/Error.aspx?id=" & errorId)
        End Try
    End Sub

#Region "Loading internals"

    Private Sub _LoadForm()
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()

            Dim cmd As New SqlCommand("
                SELECT hasBeenDeniedLicense, licenseDeniedExplanation, 
                    hasHadLicenseRevoked, licenseRevokedExplanation,
                    hasHadAccidents, hasHadConvictions
                FROM web_DriverApplication WHERE id=@appId",
                connection)
            cmd.Parameters.AddWithValue("appId", Master.app.id)
            Dim dReader = cmd.ExecuteReader()
            dReader.Read()

            'ynLicenseDenied.Checked = Logic.Conversion.ToNullableBoolean(dReader("hasBeenDeniedLicense"))
            'ynLicenseRevoked.Checked = Logic.Conversion.ToNullableBoolean(dReader("hasHadLicenseRevoked"))
            ynThreeYearsAccidents.Checked = Logic.Conversion.ToNullableBoolean(dReader("hasHadAccidents"))
            'ynThreeYearsConvictions.Checked = Logic.Conversion.ToNullableBoolean(dReader("hasHadConvictions"))
            'txtLicenseDeniedExplanation.Text = Logic.Conversion.ToString(dReader("licenseDeniedExplanation"))
            'txtLicenseRevokedExplanation.Text = Logic.Conversion.ToString(dReader("licenseRevokedExplanation"))

        End Using
    End Sub

    Private Sub _LoadLists()
        _LoadAccidentList()
    End Sub

    Private Sub _LoadAccidentList()
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()

            Dim cmdCount As New SqlCommand(
                "SELECT COUNT(id) FROM web_DriverApplicationAccidents WHERE AppId=@appId",
                connection)
            cmdCount.Parameters.AddWithValue("appId", Master.app.id)
            Dim count = CInt(cmdCount.ExecuteScalar())
            count = Math.Max(count, rptAccidents.TargetCount)

            Dim cmdAccidents As New SqlCommand("
                SELECT * FROM web_DriverApplicationAccidents
                WHERE AppId=@appId",
                connection)
            cmdAccidents.Parameters.AddWithValue("appId", Master.app.id)

            Dim dummy As New List(Of Integer)
            For i = 1 To count : dummy.Add(i) : Next
            rptAccidents.DataSource = dummy
            rptAccidents.DataBind()

            Dim dReader = cmdAccidents.ExecuteReader()
            For Each item As RepeaterItem In rptAccidents.Items
                Dim hidId As HiddenField = item.FindControl("hidAccidentId")
                Dim txtAccidentDate As TextBox = item.FindControl("txtAccidentDate")
                Dim txtAccidentNature As TextBox = item.FindControl("txtAccidentNature")
                Dim txtAccidentConsequences As TextBox = item.FindControl("txtAccidentConsequences")
                Dim txtAccidentComments As TextBox = item.FindControl("txtAccidentComments")

                If dReader.Read() Then
                    hidId.Value = dReader("id")
                    txtAccidentDate.Text = Logic.Conversion.ToDate(dReader("Date")).FormatForHtml5()
                    txtAccidentNature.Text = dReader("Nature")
                    txtAccidentConsequences.Text = dReader("Consequence")
                    txtAccidentComments.Text = dReader("Comments")
                End If
            Next

        End Using
    End Sub

    Private Sub _Prefill()
        '
    End Sub

#End Region

#Region "Saving internals"

    Private Sub _SaveAll()
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()
            Using transaction = connection.BeginTransaction()
                _SaveForm(connection, transaction)
                _SaveLists(connection, transaction)
                _SaveDocument(connection, transaction)
                transaction.Commit()
            End Using
        End Using
    End Sub

    Private Sub _SaveForm(connection As SqlConnection, transaction As SqlTransaction)

        'Dim licenseDenied = ynLicenseDenied.Checked
        'Dim licenseRevoked = ynLicenseRevoked.Checked
        Dim hadAccidents = ynThreeYearsAccidents.Checked
        'Dim hadConvictions = ynThreeYearsConvictions.Checked

        Dim cmdSave As New SqlCommand("
            UPDATE web_DriverApplication
            SET hasHadAccidents=@hasHadAccidents
            WHERE id=@appId",
            connection, transaction)

        With cmdSave.Parameters
            .AddWithValue("appId", Master.app.id)
            '.AddWithValue("hasBeenDeniedLicense", If(licenseDenied.HasValue, licenseDenied.Value, DBNull.Value))
            '.AddWithValue("licenseDeniedExplanation", If(licenseDenied.HasValue, txtLicenseDeniedExplanation.Text, DBNull.Value))
            '.AddWithValue("hasHadLicenseRevoked", If(licenseRevoked.HasValue, licenseRevoked.Value, DBNull.Value))
            '.AddWithValue("licenseRevokedExplanation", If(licenseRevoked.HasValue, txtLicenseRevokedExplanation.Text, DBNull.Value))
            .AddWithValue("hasHadAccidents", If(hadAccidents.HasValue, hadAccidents.Value, DBNull.Value))
            '.AddWithValue("hasHadConvictions", If(hadConvictions.HasValue, hadConvictions.Value, DBNull.Value))
        End With

        cmdSave.ExecuteNonQuery()

    End Sub

    Private Sub _SaveLists(connection As SqlConnection, transaction As SqlTransaction)
        _SaveAccidentList(connection, transaction)
    End Sub

    Private Sub _SaveAccidentList(connection As SqlConnection, transaction As SqlTransaction)

        Dim cmdDelete As New SqlCommand(
            "DELETE FROM web_DriverApplicationAccidents WHERE AppId=@appId",
            connection, transaction)
        cmdDelete.Parameters.AddWithValue("appId", Master.app.id)
        cmdDelete.ExecuteNonQuery()

        Dim cmdSave As New SqlCommand("
            INSERT INTO web_DriverApplicationAccidents
            (AppId, [Date], Nature, Consequence, Comments)
            VALUES (@appId, @date, @nature, @consequence, @comments);
            SELECT @@IDENTITY;",
            connection, transaction)
        With cmdSave.Parameters
            .AddWithValue("appId", Master.app.id)
            .Add(New SqlParameter("date", SqlDbType.Date))
            .Add(New SqlParameter("nature", SqlDbType.VarChar))
            .Add(New SqlParameter("consequence", SqlDbType.VarChar))
            .Add(New SqlParameter("comments", SqlDbType.VarChar))
        End With

        For Each item As RepeaterItem In rptAccidents.Items
            Dim hidId As HiddenField = item.FindControl("hidAccidentId")
            Dim txtAccidentDate As TextBox = item.FindControl("txtAccidentDate")
            Dim txtAccidentNature As TextBox = item.FindControl("txtAccidentNature")
            Dim txtAccidentConsequences As TextBox = item.FindControl("txtAccidentConsequences")
            Dim txtAccidentComments As TextBox = item.FindControl("txtAccidentComments")

            cmdSave.Parameters("date").Value = Logic.Conversion.ToDate(txtAccidentDate.Text).Clip()
            cmdSave.Parameters("nature").Value = txtAccidentNature.Text
            cmdSave.Parameters("consequence").Value = txtAccidentConsequences.Text
            cmdSave.Parameters("comments").Value = txtAccidentComments.Text

            hidId.Value = cmdSave.ExecuteScalar()
        Next

    End Sub

    Private Sub _SaveDocument(connection As SqlConnection, transaction As SqlTransaction)
        Dim ReportDataSet As New dsAppDrivingExperience
        Dim ReportTableAdapter As New TransactionalAppDrivingExperienceTableAdapter
        ReportTableAdapter.SetConnection(connection, transaction)
        ReportTableAdapter.Fill(ReportDataSet.AppDrivingExperienceDataTable, Master.app.id)

        Using Report As New crptAppDrivingExperience
            Report.SetDataSource(ReportDataSet)
            Dim rawData = Reporting.StreamToByteArray(Report)

            Dim cmdSave = "
                UPDATE web_DriverApplicationPdf SET pageTitle=@pageTitle, pdfData=@pdfData, pdfDataSize=@pdfDataSize
                WHERE appId=@appId AND pageFileName=@pageFileName;
                IF @@ROWCOUNT = 0 BEGIN
                    INSERT INTO web_DriverApplicationPdf (appId, pageTitle, pageFileName, pdfData, pdfDataSize)
                    VALUES (@appId, @pageTitle, @pageFileName, @pdfData, @pdfDataSize);
                END"
            Dim cmd As New SqlCommand(cmdSave, connection, transaction)
            cmd.Parameters.AddWithValue("appId", Master.app.id)
            cmd.Parameters.AddWithValue("pageTitle", Master.CurrentTitle)
            cmd.Parameters.AddWithValue("pageFileName", Master.CurrentPage)
            cmd.Parameters.AddWithValue("pdfData", rawData)
            cmd.Parameters.AddWithValue("pdfDataSize", rawData.Length)
            cmd.ExecuteNonQuery()
        End Using
    End Sub

#End Region

#Region "Other internals"

    Private Function _HasEnteredLastAccident() As Boolean
        Dim count = rptAccidents.Items.Count
        If count = 0 Then
            Return True
        Else
            Dim item As RepeaterItem = rptAccidents.Items(count - 1)
            Dim txtAccidentDate As TextBox = item.FindControl("txtAccidentDate")
            Return txtAccidentDate.Text.Length > 0
        End If
    End Function


    Private Function _HasVisited() As Boolean
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()
            Dim cmd As New SqlCommand(
                "SELECT hasHadConvictions FROM web_DriverApplication WHERE id=@appId",
                connection)
            cmd.Parameters.AddWithValue("appId", Master.app.id)
            Return TypeOf cmd.ExecuteScalar() IsNot DBNull
        End Using
    End Function

    Private Sub _RemoveAccident(itemId As Integer)
        Using connection As New SqlConnection(Logic.Database.ConnectionString)
            connection.Open()
            Dim cmd As New SqlCommand(
                "DELETE FROM web_DriverApplicationAccidents WHERE id=@itemId",
                connection)
            cmd.Parameters.AddWithValue("itemId", itemId)
            cmd.ExecuteNonQuery()
        End Using
    End Sub


#End Region

End Class